<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects;

use InvalidArgumentException;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\StavEmisnejKontrolyEnum;

/**
 * Class ZoznamPoctuKontrolPodlaStavu
 *
 * @package Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects
 */
final class ZoznamPoctuKontrolPodlaStavu extends ZoznamPoctuKontrolAbstract implements ZoznamPoctuKontrol
{
    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrol $pocetKontrol
     *
     * @return \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\ZoznamPoctuKontrolPodlaStavu
     */
    public function add(PocetKontrol $pocetKontrol): self
    {
        $addNewRecord = true;

        if (!$pocetKontrol instanceof PocetKontrolPodlaStavu) {
            throw new InvalidArgumentException(
                sprintf(
                    'Ocakava sa instancia triedy %s, vtupny atribut je instancie %s',
                    PocetKontrolPodlaStavu::class,
                    get_class($pocetKontrol)
                )
            );
        }

        array_walk(
            $this->items,
            function (?PocetKontrolPodlaStavu &$pocetKontrolPodlaStavu, int $index) use ($pocetKontrol, &$addNewRecord) {
                if ($pocetKontrolPodlaStavu->equalsStav($pocetKontrol)) {
                    $pocetKontrolPodlaStavu = $pocetKontrolPodlaStavu->navysitPocet($pocetKontrol);
                    $addNewRecord = false;
                }
            }
        );

        if ($addNewRecord) {
            $this->items[] = $pocetKontrol;
        }

        return new self($this->items);
    }

    /**
     * @param array $udaje
     *
     * @return self
     */
    public static function createFromArray(array $udaje): self
    {
        $zoznam = new self();

        foreach ($udaje as $udaj) {
            $zoznam->add(new PocetKontrolPodlaStavu(
                StavEmisnejKontrolyEnum::from(mb_strtoupper($udaj['stav'])),
                (int)$udaj['pocet']
            ));
        }

        return $zoznam;
    }
}
